<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CCodeRefactoring: FlattenASAMMDXxml.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(function() { init_search(); });
/* @license-end */
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CCodeRefactoring
   &#160;<span id="projectnumber">First Alpha</span>
   </div>
   <div id="projectbrief">Create Simulation Executable From Existing Code</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_flatten_a_s_a_m_m_d_xxml_8hpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">FlattenASAMMDXxml.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_flatten_a_s_a_m_m_d_xxml_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef bsoncxxType</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">    #define bsoncxxType</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/basic/array.hpp&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/basic/document.hpp&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/basic/kvp.hpp&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/stream/array.hpp&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/stream/document.hpp&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/stream/helpers.hpp&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/types.hpp&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/stdx/string_view.hpp&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/json.hpp&gt;</span> </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/types.hpp&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/basic/document.hpp&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/json.hpp&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/document/value.hpp&gt;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/stdx/string_view.hpp&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#endif </span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="struct_flatten_ctrl.html">   24</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;{</div>
<div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">   26</a></span>&#160;    std::string <a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>;</div>
<div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="struct_flatten_ctrl.html#ac60e02df2754d739c34eabbf6ed3165f">   27</a></span>&#160;    <span class="keywordtype">unsigned</span> <a class="code" href="struct_flatten_ctrl.html#ac60e02df2754d739c34eabbf6ed3165f">sibling_no</a>;    </div>
<div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="struct_flatten_ctrl.html#add126272cb1574e9891ec786c8b2db0c">   28</a></span>&#160;    <span class="keywordtype">unsigned</span> <a class="code" href="struct_flatten_ctrl.html#add126272cb1574e9891ec786c8b2db0c">sequence_no</a>;    </div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="struct_flatten_ctrl.html#a85c8866abc7073c0035c10e912a5f960">   29</a></span>&#160;    std::string <a class="code" href="struct_flatten_ctrl.html#a85c8866abc7073c0035c10e912a5f960">siblingNoAsString</a>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;} <a class="code" href="struct_flatten_ctrl.html">FlattenCtrl</a>;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="structbson_docu_strct.html">   35</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;{</div>
<div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="structbson_docu_strct.html#a592a72ec9d9e55792b121ad81659b3b8">   37</a></span>&#160;    bsoncxx::stdx::string_view <a class="code" href="structbson_docu_strct.html#a592a72ec9d9e55792b121ad81659b3b8">key</a>;</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="structbson_docu_strct.html#a777a7b87a23cddb7755ec00c41bcdb01">   38</a></span>&#160;    std::string <a class="code" href="structbson_docu_strct.html#a777a7b87a23cddb7755ec00c41bcdb01">index</a>;</div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="structbson_docu_strct.html#ab2fe3272f989da3717ffcd1c842669f0">   39</a></span>&#160;    std::string <a class="code" href="structbson_docu_strct.html#ab2fe3272f989da3717ffcd1c842669f0">isArrayNo</a>;</div>
<div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="structbson_docu_strct.html#ad6c61cc5bd2e453a299e0bbdb39df262">   40</a></span>&#160;    bsoncxx::document::value <a class="code" href="structbson_docu_strct.html#ad6c61cc5bd2e453a299e0bbdb39df262">document</a>;      </div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="structbson_docu_strct.html#aa6ea81c5be3c41df94b6ae31bf5d3f4c">   41</a></span>&#160;    std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; <a class="code" href="structbson_docu_strct.html#aa6ea81c5be3c41df94b6ae31bf5d3f4c">history</a>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;} <a class="code" href="structbson_docu_strct.html">bsonDocuStrct</a>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">using</span> bsoncxx::builder::basic::make_document;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div>
<div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#af6f8a613735677bcd27d169e64a2bacb">   46</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#af6f8a613735677bcd27d169e64a2bacb">appendBSONDoc</a>(bsoncxx::builder::basic::document&amp; builder,<span class="keyword">enum</span> bsoncxx::type&amp; tp,bsoncxx::document::element&amp; el)</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;{</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="comment">// see bsoncxx/enum/type.hpp</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">auto</span> temp1 = el.key();</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">auto</span> temp2 = el.get_value();</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    bsoncxx::document::view init{};</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    bsoncxx::document::value doc{init};</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordflow">switch</span>(el.type())</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    {</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_double : {  builder.append(kvp(el.key(),el.get_double()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_utf8 : {  builder.append(kvp(el.key(),el.get_utf8()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_binary : {  builder.append(kvp(el.key(),el.get_binary()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_undefined : {  builder.append(kvp(el.key(),el.get_undefined()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_oid : {  builder.append(kvp(el.key(),el.get_oid()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_bool : { builder.append(kvp(el.key(),el.get_bool()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_date : {  builder.append(kvp(el.key(),el.get_date()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_null : {  builder.append(kvp(el.key(),el.get_null()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_regex : { builder.append(kvp(el.key(),el.get_regex()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_dbpointer : { builder.append(kvp(el.key(),el.get_dbpointer()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_code : {  builder.append(kvp(el.key(),el.get_code()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_symbol : {  builder.append(kvp(el.key(),el.get_symbol()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_codewscope : {  builder.append(kvp(el.key(),el.get_codewscope()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_int32 : {  builder.append(kvp(el.key(),el.get_int32()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_timestamp : { builder.append(kvp(el.key(),el.get_timestamp())); } <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_int64 : {   builder.append(kvp(el.key(),el.get_int64()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_decimal128 : {  builder.append(kvp(el.key(),el.get_decimal128()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_maxkey : { builder.append(kvp(el.key(),el.get_maxkey()));} <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_minkey : { builder.append(kvp(el.key(),el.get_minkey())); } <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    }</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    </div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;}</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a31ae7c111f6f573afd5fa501dad5eae5">   79</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a31ae7c111f6f573afd5fa501dad5eae5">appendBSONArray</a>(bsoncxx::builder::basic::array&amp; array_builder,<span class="keyword">enum</span> bsoncxx::type&amp; tp,bsoncxx::array::element&amp; el)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;{</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="comment">// see bsoncxx/enum/type.hpp</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160; </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordflow">switch</span>(tp)</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    {</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_double :  array_builder.append(make_document(kvp(el.key(),el.get_double()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_utf8 :    array_builder.append(make_document(kvp(el.key(),el.get_utf8()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_document : </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        {</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            bsoncxx::document::view vw = el.get_document();</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            <span class="keywordflow">for</span>(bsoncxx::document::view::iterator i=vw.begin();i!=vw.end();i++)</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            {</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;                <span class="keyword">auto</span> cur = *i;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;                array_builder.append(make_document(kvp(el.key(),cur.key())));                               </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            }</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        } </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_array : </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        {</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            bsoncxx::array::view vw = el.get_array();</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            <span class="keywordflow">for</span>(bsoncxx::array::view::iterator i=vw.begin();i!=vw.end();i++)</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            {</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;                <span class="keyword">auto</span> cur = *i;                  </div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                array_builder.append(make_document(kvp(el.key(),cur.key())));               </div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            }</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        } </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_binary :  array_builder.append(make_document(kvp(el.key(),el.get_binary()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_undefined :  array_builder.append(make_document(kvp(el.key(),el.get_undefined()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_oid :  array_builder.append(make_document(kvp(el.key(),el.get_oid()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_bool : array_builder.append(make_document(kvp(el.key(),el.get_bool()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_date :  array_builder.append(make_document(kvp(el.key(),el.get_date()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_null :  array_builder.append(make_document(kvp(el.key(),el.get_null()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_regex : array_builder.append(make_document(kvp(el.key(),el.get_regex()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_dbpointer : array_builder.append(make_document(kvp(el.key(),el.get_dbpointer()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_code :  array_builder.append(make_document(kvp(el.key(),el.get_code()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_symbol :  array_builder.append(make_document(kvp(el.key(),el.get_symbol()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_codewscope :  array_builder.append(make_document(kvp(el.key(),el.get_codewscope()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_int32 :  array_builder.append(make_document(kvp(el.key(),el.get_int32()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_timestamp : array_builder.append(make_document(kvp(el.key(),el.get_timestamp())));  <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_int64 :  array_builder.append(make_document(kvp(el.key(),el.get_int64()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_decimal128 : array_builder.append(make_document(kvp(el.key(),el.get_decimal128()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_maxkey : array_builder.append(make_document(kvp(el.key(),el.get_maxkey()))); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keywordflow">case</span> bsoncxx::type::k_minkey : array_builder.append(make_document(kvp(el.key(),el.get_minkey())));  <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    }</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160; </div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;}</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160; </div>
<div class="line"><a name="l00129"></a><span class="lineno"><a class="line" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#aecf48ba4ea77ffdbcb4d6b2432891d21">  129</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#aecf48ba4ea77ffdbcb4d6b2432891d21">incrementCounters</a>(<a class="code" href="struct_flatten_ctrl.html">FlattenCtrl</a>&amp; ctrl,std::string parent_index)</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;{</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        ctrl.<a class="code" href="struct_flatten_ctrl.html#add126272cb1574e9891ec786c8b2db0c">sequence_no</a> ++;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        ctrl.<a class="code" href="struct_flatten_ctrl.html#ac60e02df2754d739c34eabbf6ed3165f">sibling_no</a> ++;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        std::string s = std::to_string(ctrl.<a class="code" href="struct_flatten_ctrl.html#ac60e02df2754d739c34eabbf6ed3165f">sibling_no</a>);        </div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        ctrl.<a class="code" href="struct_flatten_ctrl.html#a85c8866abc7073c0035c10e912a5f960">siblingNoAsString</a> = s;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a> = parent_index + s + <span class="stringliteral">&quot;.&quot;</span>;    </div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;}</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160; </div>
<div class="line"><a name="l00138"></a><span class="lineno"><a class="line" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a6f1279cdeb2de73176b7a0cacd05d5ba">  138</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a6f1279cdeb2de73176b7a0cacd05d5ba">flattenBSONCXX</a>(bsoncxx::document::view mdx_bdocview,std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; history_vec,bsoncxx::stdx::string_view parent_key,<a class="code" href="struct_flatten_ctrl.html">FlattenCtrl</a>&amp; ctrl,std::string ID,std::string arrNo=<span class="stringliteral">&quot;none&quot;</span>)</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;{</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keyword">using</span> bsoncxx::builder::basic::make_document;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    </div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    ctrl.<a class="code" href="struct_flatten_ctrl.html#ac60e02df2754d739c34eabbf6ed3165f">sibling_no</a> = 0;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    bsoncxx::builder::basic::document Node; </div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    std::string parent_index = ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    </div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <span class="comment">//---------------------------------------------------------------------</span></div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="comment">// Iterate across all siblings</span></div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    <span class="comment">//---------------------------------------------------------------------</span></div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    std::vector&lt;bsonDocuStrct&gt; documents;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    </div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160; </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="keywordflow">for</span>(bsoncxx::document::view::const_iterator it = mdx_bdocview.begin(); it != mdx_bdocview.end();it++)</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    {</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; node_history_vec = history_vec;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160; </div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        Node.append(kvp(<span class="stringliteral">&quot;identifier&quot;</span>,ID));</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        Node.append(kvp(<span class="stringliteral">&quot;parent_index&quot;</span>,parent_index));</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        Node.append(kvp(<span class="stringliteral">&quot;parent_arrayNo&quot;</span>,arrNo));</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160; </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        bsoncxx::document::view init{};</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        bsoncxx::document::value doc_init(init);</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <a class="code" href="structbson_docu_strct.html">bsonDocuStrct</a> document  = { <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>,<span class="stringliteral">&quot;none&quot;</span>, doc_init,history_vec};</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160; </div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#aecf48ba4ea77ffdbcb4d6b2432891d21">incrementCounters</a>(ctrl,parent_index);</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        document.<a class="code" href="structbson_docu_strct.html#a777a7b87a23cddb7755ec00c41bcdb01">index</a> = ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                </div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        Node.append(kvp(<span class="stringliteral">&quot;parentname&quot;</span>,parent_key));</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        </div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;                </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        bsoncxx::document::element cur = *it;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keyword">enum</span> bsoncxx::type tp = cur.type();</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="keyword">auto</span>    loc_key = cur.key();</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        document.<a class="code" href="structbson_docu_strct.html#a592a72ec9d9e55792b121ad81659b3b8">key</a> = loc_key;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        Node.append(kvp(<span class="stringliteral">&quot;name&quot;</span>,loc_key));</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160; </div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        std::pair&lt;std::string,std::string&gt; history_pair;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        history_pair.first = loc_key.to_string();</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        history_pair.second = ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        node_history_vec.push_back(history_pair);</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160; </div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="keywordflow">if</span>(history_pair.first.compare(<span class="stringliteral">&quot;SW-INSTANCE&quot;</span>)==0)</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        {</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;            std::string test = <span class="stringliteral">&quot;test&quot;</span>;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        }</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    </div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        bsoncxx::builder::basic::array outer_array_builder = bsoncxx::builder::basic::array{};</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160; </div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=0;i&lt;history_vec.size();i++)</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        {           </div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            std::pair&lt;std::string,std::string&gt; loc_pair =  history_vec[i];</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            outer_array_builder.append(make_document(kvp(loc_pair.first,loc_pair.second)));         </div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        }</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        </div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    </div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        bsoncxx::types::bson_value::view val_vw = cur.get_value();</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160; </div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="comment">//---------------------------------------------------------------------</span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="comment">// Iterate across all array elements - the array elements</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="comment">// are considered as the next child level</span></div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="comment">//---------------------------------------------------------------------</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    </div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keywordflow">if</span>(tp == bsoncxx::type::k_array)</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        {</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;            <a class="code" href="struct_flatten_ctrl.html">FlattenCtrl</a> array_ctrl;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;            std::string array_parent_index = ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            array_ctrl.<a class="code" href="struct_flatten_ctrl.html#ac60e02df2754d739c34eabbf6ed3165f">sibling_no</a> = 0;          </div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;            <a class="code" href="structbson_docu_strct.html">bsonDocuStrct</a> document_in_array  = { <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>,<span class="stringliteral">&quot;none&quot;</span>, doc_init,node_history_vec};</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160; </div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;            bsoncxx::array::view avw = cur.get_array();     </div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            bsoncxx::builder::basic::array array_builder = bsoncxx::builder::basic::array{};    </div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            bsoncxx::builder::basic::array array_indices = bsoncxx::builder::basic::array{};    </div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;            bsoncxx::builder::basic::array array_keys = bsoncxx::builder::basic::array{};   </div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;            </div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;            <span class="keywordtype">unsigned</span> counter=0;     </div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;            <span class="keywordflow">for</span>(bsoncxx::array::view::const_iterator avwIt = avw.begin(); avwIt != avw.end();avwIt++)</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;            {</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;                <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#aecf48ba4ea77ffdbcb4d6b2432891d21">incrementCounters</a>(array_ctrl,array_parent_index);</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;                document_in_array.<a class="code" href="structbson_docu_strct.html#a777a7b87a23cddb7755ec00c41bcdb01">index</a> = array_ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;                document_in_array.<a class="code" href="structbson_docu_strct.html#ab2fe3272f989da3717ffcd1c842669f0">isArrayNo</a>=array_ctrl.<a class="code" href="struct_flatten_ctrl.html#a85c8866abc7073c0035c10e912a5f960">siblingNoAsString</a>;</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160; </div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;                std::pair&lt;std::string,std::string&gt; keyIdPair;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                keyIdPair.first = parent_key.to_string();</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;                keyIdPair.second = array_ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>;                    </div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;                document_in_array.<a class="code" href="structbson_docu_strct.html#aa6ea81c5be3c41df94b6ae31bf5d3f4c">history</a>.push_back(keyIdPair);</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;                </div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160; </div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;                <span class="keyword">auto</span> cur_ar = *avwIt;</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;                <span class="keyword">enum</span> bsoncxx::type artp = cur_ar.type();                </div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;                <span class="keyword">auto</span>    loc_ar_key = cur_ar.key();                              </div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;                document_in_array.<a class="code" href="structbson_docu_strct.html#a592a72ec9d9e55792b121ad81659b3b8">key</a> = loc_ar_key;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160; </div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;                bsoncxx::array::element el = avw[counter];</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;                </div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;                <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a31ae7c111f6f573afd5fa501dad5eae5">appendBSONArray</a>(array_builder,artp,el);</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160; </div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;                </div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160; </div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;                <span class="keywordflow">if</span>(artp == bsoncxx::type::k_document)</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;                {                                       </div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;                    bsoncxx::document::view bvw = el.get_document();</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;                    std::string <a class="code" href="_write_j_s_o_n_report_8h.html#ab701e3ac61a85b337ec5c1abaad6742d">json</a> = bsoncxx::to_json(bvw);</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;                    bsoncxx::document::value temp(bvw);</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;                    document_in_array.<a class="code" href="structbson_docu_strct.html#ad6c61cc5bd2e453a299e0bbdb39df262">document</a> = temp;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160; </div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;                </div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160; </div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160; </div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;                    documents.push_back(document_in_array);</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;                    </div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;                    </div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;                    array_indices.append(make_document(kvp(array_ctrl.<a class="code" href="struct_flatten_ctrl.html#a85c8866abc7073c0035c10e912a5f960">siblingNoAsString</a>,array_ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>)));</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;                    <span class="comment">//array_keys.append(make_document(kvp(&quot;key&quot;,loc_ar_key)));              </span></div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;                    array_keys.append(loc_ar_key);  </div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160; </div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160; </div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;                </div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;                }</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;                <span class="keywordflow">if</span>(artp == bsoncxx::type::k_array)</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;                {</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;                    bsoncxx::array::view subarr{el.get_array().value};</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;                    std::string <a class="code" href="_write_j_s_o_n_report_8h.html#ab701e3ac61a85b337ec5c1abaad6742d">json</a> = bsoncxx::to_json(subarr);</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;                    <span class="comment">//bsoncxx::array::value subarr_vw(subarr);                  </span></div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;                    Node.append(kvp(<span class="stringliteral">&quot;sub_array&quot;</span>,subarr));</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;                }</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;                counter++;</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;                document_in_array.<a class="code" href="structbson_docu_strct.html#aa6ea81c5be3c41df94b6ae31bf5d3f4c">history</a> = node_history_vec;</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;            }</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;            Node.append(kvp(<span class="stringliteral">&quot;array_keys&quot;</span>,array_keys));</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;            Node.append(kvp(<span class="stringliteral">&quot;array_indices&quot;</span>,array_indices));</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;            Node.append(kvp(<span class="stringliteral">&quot;hierarchy&quot;</span>,outer_array_builder));              </div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;            Node.append(kvp(<span class="stringliteral">&quot;values&quot;</span>,array_builder));</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;            std::string <a class="code" href="_write_j_s_o_n_report_8h.html#ab701e3ac61a85b337ec5c1abaad6742d">json</a> = bsoncxx::to_json(Node.view());       </div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160; </div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        }</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        <span class="keywordflow">else</span> <span class="keywordflow">if</span>(tp == bsoncxx::type::k_document)</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        {</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;            <a class="code" href="struct_flatten_ctrl.html">FlattenCtrl</a> array_ctrl;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;            std::string array_parent_index = ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>;</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;            array_ctrl.<a class="code" href="struct_flatten_ctrl.html#ac60e02df2754d739c34eabbf6ed3165f">sibling_no</a> = 0;</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;            <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#aecf48ba4ea77ffdbcb4d6b2432891d21">incrementCounters</a>(array_ctrl,array_parent_index);           </div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            bsoncxx::builder::basic::array array_indices = bsoncxx::builder::basic::array{};</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            array_indices.append(make_document(kvp(array_ctrl.<a class="code" href="struct_flatten_ctrl.html#a85c8866abc7073c0035c10e912a5f960">siblingNoAsString</a>,array_ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>)));                            </div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;            Node.append(kvp(<span class="stringliteral">&quot;array_indices&quot;</span>,array_indices));</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            Node.append(kvp(loc_key,<span class="stringliteral">&quot;see_sub_document&quot;</span>));</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            Node.append(kvp(<span class="stringliteral">&quot;hierarchy&quot;</span>,outer_array_builder));              </div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;            bsoncxx::document::view bvw = cur.get_document();</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;            bsoncxx::document::value temp(bvw);</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;            document.<a class="code" href="structbson_docu_strct.html#ad6c61cc5bd2e453a299e0bbdb39df262">document</a> = temp;</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;            documents.push_back(document);</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160; </div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            std::pair&lt;std::string,std::string&gt; keyIdPair;</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;            keyIdPair.first = parent_key.to_string();</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;            keyIdPair.second = parent_index;</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;            document.<a class="code" href="structbson_docu_strct.html#aa6ea81c5be3c41df94b6ae31bf5d3f4c">history</a>.push_back(keyIdPair);          </div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;            </div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        }</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;        <span class="keywordflow">else</span> </div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        {</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;            <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#af6f8a613735677bcd27d169e64a2bacb">appendBSONDoc</a>(Node,tp,cur); </div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        }</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;        std::string <a class="code" href="_write_j_s_o_n_report_8h.html#ab701e3ac61a85b337ec5c1abaad6742d">json</a> = bsoncxx::to_json(Node.view());       </div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;        Node.append(kvp(<span class="stringliteral">&quot;index&quot;</span>,ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>));   </div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160; </div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    </div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        </div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        </div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;FlattenedMDX&quot;</span>,<span class="stringliteral">&quot;MDX&quot;</span>,Node.extract());                  </div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160; </div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    }</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160; </div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;    <span class="keywordflow">for</span>(std::vector&lt;bsonDocuStrct&gt;::iterator docIt=documents.begin();docIt!=documents.end();docIt++)</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    {</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;            <a class="code" href="structbson_docu_strct.html">bsonDocuStrct</a> doc_strct = *docIt;</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;            bsoncxx::document::view view = doc_strct.<a class="code" href="structbson_docu_strct.html#ad6c61cc5bd2e453a299e0bbdb39df262">document</a>.view();                   </div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;            <a class="code" href="struct_flatten_ctrl.html">FlattenCtrl</a> subCtrl;</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;            subCtrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a> = doc_strct.<a class="code" href="structbson_docu_strct.html#a777a7b87a23cddb7755ec00c41bcdb01">index</a>;            </div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;            std::string <a class="code" href="_write_j_s_o_n_report_8h.html#ab701e3ac61a85b337ec5c1abaad6742d">json</a> = bsoncxx::to_json(view);              </div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;            <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a6f1279cdeb2de73176b7a0cacd05d5ba">flattenBSONCXX</a>(view,doc_strct.<a class="code" href="structbson_docu_strct.html#aa6ea81c5be3c41df94b6ae31bf5d3f4c">history</a>,doc_strct.<a class="code" href="structbson_docu_strct.html#a592a72ec9d9e55792b121ad81659b3b8">key</a>,subCtrl,ID,doc_strct.<a class="code" href="structbson_docu_strct.html#ab2fe3272f989da3717ffcd1c842669f0">isArrayNo</a>);            </div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    }</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;}</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160; </div>
<div class="line"><a name="l00324"></a><span class="lineno"><a class="line" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a41eefa0f417a930ad5a27102a9575fef">  324</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a41eefa0f417a930ad5a27102a9575fef">flattenRequestedXML</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;{</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;    <span class="keywordtype">unsigned</span> cntr=0;</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    <a class="code" href="postgres_interface_8hpp.html#a952e42de50e86fdd1ac069a8acf991e1">createPgTables</a>(<span class="stringliteral">&quot;FlattenedMDX&quot;</span>,<span class="stringliteral">&quot;MDX&quot;</span>);  </div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    std::vector&lt;std::string&gt; requestedXMLFeatures;</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    requestedXMLFeatures.push_back(<span class="stringliteral">&quot;ASMod_VolEff&quot;</span>);</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    requestedXMLFeatures.push_back(<span class="stringliteral">&quot;ASMod_Co&quot;</span>);</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    requestedXMLFeatures.push_back(<span class="stringliteral">&quot;ASMod_AxisPoints&quot;</span>);</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160; </div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> rqFtIt=0;rqFtIt&lt;requestedXMLFeatures.size();rqFtIt++)</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;    {       </div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;        std::vector&lt;std::string&gt; ident_vec;</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;        std::string currentFeature = requestedXMLFeatures[rqFtIt];</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;        std::string queryStr_1 = <span class="stringliteral">&quot;SELECT report FROM public.mdxreport WHERE report-&gt;&#39;MSRSW&#39;-&gt;&#39;SW-SYSTEMS&#39;-&gt;0-&gt;&#39;SW-SYSTEM&#39;-&gt;0-&gt;&#39;SW-COMPONENT-SPEC&#39;-&gt;0-&gt;&#39;SW-COMPONENTS&#39;-&gt;0-&gt;&#39;SW-FEATURE&#39;-&gt;0-&gt;&#39;SHORT-NAME&#39;-&gt;0 = &#39;\&quot;&quot;</span>+requestedXMLFeatures[rqFtIt]+<span class="stringliteral">&quot;\&quot; &#39;;&quot;</span>; </div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;        std::vector&lt;std::vector&lt;std::string&gt;&gt; resMdx_vec = <a class="code" href="postgres_interface_8hpp.html#a23641ff228bc4a84c18a7ae15c42ed77">genericQuery</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,queryStr_1);</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160; </div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;        <span class="keywordflow">for</span>(std::vector&lt;std::vector&lt;std::string&gt;&gt;::iterator it = resMdx_vec.begin();it != resMdx_vec.end();it++)</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;        {</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;            cntr++;</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160; </div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;            std::vector&lt;std::string&gt; res_vec = *it;</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;            std::string mdx = res_vec[0];</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160; </div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;            bsoncxx::document::value mdx_bdocval = bsoncxx::from_json(mdx);</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;            bsoncxx::document::view mdx_bdocview = mdx_bdocval.view();</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160; </div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;            std::string s = currentFeature + <span class="stringliteral">&quot;_&quot;</span> + std::to_string(cntr);        </div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;            ident_vec.push_back(s);</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160; </div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;            <a class="code" href="struct_flatten_ctrl.html">FlattenCtrl</a> ctrl;</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;            ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a> = <span class="stringliteral">&quot;1.&quot;</span>;</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;            ctrl.<a class="code" href="struct_flatten_ctrl.html#add126272cb1574e9891ec786c8b2db0c">sequence_no</a> = 0;</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160; </div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;            std::pair&lt;std::string,std::string&gt; keyIdPair;</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;            std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; keyIdPair_vec;</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;            </div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;            keyIdPair.first = <span class="stringliteral">&quot;root&quot;</span>;</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;            keyIdPair.second = ctrl.<a class="code" href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">index</a>;</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;            keyIdPair_vec.push_back(keyIdPair);</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160; </div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;            <a class="code" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a6f1279cdeb2de73176b7a0cacd05d5ba">flattenBSONCXX</a>(mdx_bdocview,keyIdPair_vec,<span class="stringliteral">&quot;root&quot;</span>,ctrl,s);           </div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;            </div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;        }</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;    }</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;    <a class="code" href="postgres_interface_8hpp.html#a04ff0f05467fdbf12c44aee405f98832">updateOneInDocument</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;public.initialdir&quot;</span>,<span class="stringliteral">&quot;toolsctrl&quot;</span>,<span class="stringliteral">&quot;reqmetamodelstruct&quot;</span>,<span class="stringliteral">&quot;false&quot;</span>);   </div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="apostgres_interface_8hpp_html_a23641ff228bc4a84c18a7ae15c42ed77"><div class="ttname"><a href="postgres_interface_8hpp.html#a23641ff228bc4a84c18a7ae15c42ed77">genericQuery</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; std::string &gt; &gt; genericQuery(std::string dbName, std::string query)</div><div class="ttdef"><b>Definition:</b> postgresInterface.hpp:759</div></div>
<div class="ttc" id="astructbson_docu_strct_html_a777a7b87a23cddb7755ec00c41bcdb01"><div class="ttname"><a href="structbson_docu_strct.html#a777a7b87a23cddb7755ec00c41bcdb01">bsonDocuStrct::index</a></div><div class="ttdeci">std::string index</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:38</div></div>
<div class="ttc" id="astruct_flatten_ctrl_html_a85c8866abc7073c0035c10e912a5f960"><div class="ttname"><a href="struct_flatten_ctrl.html#a85c8866abc7073c0035c10e912a5f960">FlattenCtrl::siblingNoAsString</a></div><div class="ttdeci">std::string siblingNoAsString</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:29</div></div>
<div class="ttc" id="a_flatten_a_s_a_m_m_d_xxml_8hpp_html_a41eefa0f417a930ad5a27102a9575fef"><div class="ttname"><a href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a41eefa0f417a930ad5a27102a9575fef">flattenRequestedXML</a></div><div class="ttdeci">void flattenRequestedXML(void)</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:324</div></div>
<div class="ttc" id="a_flatten_a_s_a_m_m_d_xxml_8hpp_html_af6f8a613735677bcd27d169e64a2bacb"><div class="ttname"><a href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#af6f8a613735677bcd27d169e64a2bacb">appendBSONDoc</a></div><div class="ttdeci">void appendBSONDoc(bsoncxx::builder::basic::document &amp;builder, enum bsoncxx::type &amp;tp, bsoncxx::document::element &amp;el)</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:46</div></div>
<div class="ttc" id="apostgres_interface_8hpp_html_a04ff0f05467fdbf12c44aee405f98832"><div class="ttname"><a href="postgres_interface_8hpp.html#a04ff0f05467fdbf12c44aee405f98832">updateOneInDocument</a></div><div class="ttdeci">bool updateOneInDocument(std::string dbName, std::string tableName, std::string columnName, std::string elementName, std::string value, std::string compareValue=&quot;&quot;)</div><div class="ttdef"><b>Definition:</b> postgresInterface.hpp:102</div></div>
<div class="ttc" id="a_flatten_a_s_a_m_m_d_xxml_8hpp_html_a6f1279cdeb2de73176b7a0cacd05d5ba"><div class="ttname"><a href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a6f1279cdeb2de73176b7a0cacd05d5ba">flattenBSONCXX</a></div><div class="ttdeci">void flattenBSONCXX(bsoncxx::document::view mdx_bdocview, std::vector&lt; std::pair&lt; std::string, std::string &gt;&gt; history_vec, bsoncxx::stdx::string_view parent_key, FlattenCtrl &amp;ctrl, std::string ID, std::string arrNo=&quot;none&quot;)</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:138</div></div>
<div class="ttc" id="a_flatten_a_s_a_m_m_d_xxml_8hpp_html_a31ae7c111f6f573afd5fa501dad5eae5"><div class="ttname"><a href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#a31ae7c111f6f573afd5fa501dad5eae5">appendBSONArray</a></div><div class="ttdeci">void appendBSONArray(bsoncxx::builder::basic::array &amp;array_builder, enum bsoncxx::type &amp;tp, bsoncxx::array::element &amp;el)</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:79</div></div>
<div class="ttc" id="astruct_flatten_ctrl_html_a952bcc74b9e11a31eb45aba996d50333"><div class="ttname"><a href="struct_flatten_ctrl.html#a952bcc74b9e11a31eb45aba996d50333">FlattenCtrl::index</a></div><div class="ttdeci">std::string index</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:26</div></div>
<div class="ttc" id="astruct_flatten_ctrl_html_add126272cb1574e9891ec786c8b2db0c"><div class="ttname"><a href="struct_flatten_ctrl.html#add126272cb1574e9891ec786c8b2db0c">FlattenCtrl::sequence_no</a></div><div class="ttdeci">unsigned sequence_no</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:28</div></div>
<div class="ttc" id="apostgres_interface_8hpp_html_a93a897241339ada0d6a3676765ae1d21"><div class="ttname"><a href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a></div><div class="ttdeci">bool insertOneIntoCollection(std::string dbName, std::string table, std::string column, bsoncxx::document::value doc_val)</div><div class="ttdef"><b>Definition:</b> postgresInterface.hpp:66</div></div>
<div class="ttc" id="astructbson_docu_strct_html_ad6c61cc5bd2e453a299e0bbdb39df262"><div class="ttname"><a href="structbson_docu_strct.html#ad6c61cc5bd2e453a299e0bbdb39df262">bsonDocuStrct::document</a></div><div class="ttdeci">bsoncxx::document::value document</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:40</div></div>
<div class="ttc" id="apostgres_interface_8hpp_html_a952e42de50e86fdd1ac069a8acf991e1"><div class="ttname"><a href="postgres_interface_8hpp.html#a952e42de50e86fdd1ac069a8acf991e1">createPgTables</a></div><div class="ttdeci">int createPgTables(std::string table_name, std::string column_name)</div><div class="ttdef"><b>Definition:</b> postgresInterface.hpp:597</div></div>
<div class="ttc" id="astructbson_docu_strct_html_ab2fe3272f989da3717ffcd1c842669f0"><div class="ttname"><a href="structbson_docu_strct.html#ab2fe3272f989da3717ffcd1c842669f0">bsonDocuStrct::isArrayNo</a></div><div class="ttdeci">std::string isArrayNo</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:39</div></div>
<div class="ttc" id="astructbson_docu_strct_html_aa6ea81c5be3c41df94b6ae31bf5d3f4c"><div class="ttname"><a href="structbson_docu_strct.html#aa6ea81c5be3c41df94b6ae31bf5d3f4c">bsonDocuStrct::history</a></div><div class="ttdeci">std::vector&lt; std::pair&lt; std::string, std::string &gt; &gt; history</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:41</div></div>
<div class="ttc" id="astructbson_docu_strct_html"><div class="ttname"><a href="structbson_docu_strct.html">bsonDocuStrct</a></div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:35</div></div>
<div class="ttc" id="a_flatten_a_s_a_m_m_d_xxml_8hpp_html_aecf48ba4ea77ffdbcb4d6b2432891d21"><div class="ttname"><a href="_flatten_a_s_a_m_m_d_xxml_8hpp.html#aecf48ba4ea77ffdbcb4d6b2432891d21">incrementCounters</a></div><div class="ttdeci">void incrementCounters(FlattenCtrl &amp;ctrl, std::string parent_index)</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:129</div></div>
<div class="ttc" id="a_write_j_s_o_n_report_8h_html_ab701e3ac61a85b337ec5c1abaad6742d"><div class="ttname"><a href="_write_j_s_o_n_report_8h.html#ab701e3ac61a85b337ec5c1abaad6742d">json</a></div><div class="ttdeci">nlohmann::json json</div><div class="ttdef"><b>Definition:</b> WriteJSONReport.h:9</div></div>
<div class="ttc" id="astruct_flatten_ctrl_html_ac60e02df2754d739c34eabbf6ed3165f"><div class="ttname"><a href="struct_flatten_ctrl.html#ac60e02df2754d739c34eabbf6ed3165f">FlattenCtrl::sibling_no</a></div><div class="ttdeci">unsigned sibling_no</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:27</div></div>
<div class="ttc" id="astruct_flatten_ctrl_html"><div class="ttname"><a href="struct_flatten_ctrl.html">FlattenCtrl</a></div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:24</div></div>
<div class="ttc" id="astructbson_docu_strct_html_a592a72ec9d9e55792b121ad81659b3b8"><div class="ttname"><a href="structbson_docu_strct.html#a592a72ec9d9e55792b121ad81659b3b8">bsonDocuStrct::key</a></div><div class="ttdeci">bsoncxx::stdx::string_view key</div><div class="ttdef"><b>Definition:</b> FlattenASAMMDXxml.hpp:37</div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="_flatten_a_s_a_m_m_d_xxml_8hpp.html">FlattenASAMMDXxml.hpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
